/*
 * Generated S-box files.
 *
 * This software may be modified, redistributed, and used for any purpose,
 * so long as its origin is acknowledged.
 *
 * Produced by Matthew Kwan - May 1998
 */


static void
s1 (
	altivec	a1,
	altivec	a2,
	altivec	a3,
	altivec	a4,
	altivec	a5,
	altivec	a6,
	altivec	*out1,
	altivec	*out2,
	altivec	*out3,
	altivec	*out4
) {
	altivec	x1, x2, x3, x4, x5, x6, x7, x8;
	altivec	x9, x10, x11, x12, x13, x14, x15, x16;
	altivec	x17, x18, x19, x20, x21, x22, x23, x24;
	altivec	x25, x26, x27, x28, x29, x30, x31, x32;
	altivec	x33, x34, x35, x36, x37, x38, x39, x40;
	altivec	x41, x42, x43, x44, x45, x46, x47, x48;
	altivec	x49, x50, x51, x52, x53, x54, x55, x56;

	x1 = vec_andc(a3, a5);
	x2 = vec_xor(x1, a4);
	x3 = vec_andc(a3, a4);
	x4 = vec_or(x3, a5);
	x5 = vec_and(a6, x4);
	x6 = vec_xor(x2, x5);
	x7 = vec_andc(a4, a5);
	x8 = vec_xor(a3, a4);
	x9 = vec_andc(a6, x8);
	x10 = vec_xor(x7, x9);
	x11 = vec_or(a2, x10);
	x12 = vec_xor(x6, x11);
	x13 = vec_xor(a5, x5);
	x14 = vec_and(x13, x8);
	x15 = vec_andc(a5, a4);
	x16 = vec_xor(x3, x14);
	x17 = vec_or(a6, x16);
	x18 = vec_xor(x15, x17);
	x19 = vec_or(a2, x18);
	x20 = vec_xor(x14, x19);
	x21 = vec_and(a1, x20);
	x22 = vec_xor(x12, x21);
	x22 = vec_nor(x22, x22);
	*out2 = vec_xor(*out2, x22);
	x23 = vec_or(x1, x5);
	x24 = vec_xor(x23, x8);
	x25 = vec_andc(x18, x2);
	x26 = vec_andc(a2, x25);
	x27 = vec_xor(x24, x26);
	x28 = vec_or(x6, x7);
	x29 = vec_xor(x28, x25);
	x30 = vec_xor(x9, x24);
	x31 = vec_andc(x18, x30);
	x32 = vec_and(a2, x31);
	x33 = vec_xor(x29, x32);
	x34 = vec_and(a1, x33);
	x35 = vec_xor(x27, x34);
	*out4 = vec_xor(*out4, x35);
	x36 = vec_and(a3, x28);
	x37 = vec_andc(x18, x36);
	x38 = vec_or(a2, x3);
	x39 = vec_xor(x37, x38);
	x40 = vec_or(a3, x31);
	x41 = vec_andc(x24, x37);
	x42 = vec_or(x41, x3);
	x43 = vec_andc(x42, a2);
	x44 = vec_xor(x40, x43);
	x45 = vec_andc(a1, x44);
	x46 = vec_xor(x39, x45);
	x46 = vec_nor(x46, x46);
	*out1 = vec_xor(*out1, x46);
	x47 = vec_andc(x33, x9);
	x48 = vec_xor(x47, x39);
	x49 = vec_xor(x4, x36);
	x50 = vec_andc(x49, x5);
	x51 = vec_or(x42, x18);
	x52 = vec_xor(x51, a5);
	x53 = vec_andc(a2, x52);
	x54 = vec_xor(x50, x53);
	x55 = vec_or(a1, x54);
	x56 = vec_xor(x48, x55);
	x56 = vec_nor(x56, x56);
	*out3 = vec_xor(*out3, x56);
}


static void
s2 (
	altivec	a1,
	altivec	a2,
	altivec	a3,
	altivec	a4,
	altivec	a5,
	altivec	a6,
	altivec	*out1,
	altivec	*out2,
	altivec	*out3,
	altivec	*out4
) {
	altivec	x1, x2, x3, x4, x5, x6, x7, x8;
	altivec	x9, x10, x11, x12, x13, x14, x15, x16;
	altivec	x17, x18, x19, x20, x21, x22, x23, x24;
	altivec	x25, x26, x27, x28, x29, x30, x31, x32;
	altivec	x33, x34, x35, x36, x37, x38, x39, x40;
	altivec	x41, x42, x43, x44, x45, x46, x47, x48;
	altivec	x49, x50;

	x1 = vec_xor(a1, a6);
	x2 = vec_xor(x1, a5);
	x3 = vec_and(a6, a5);
	x4 = vec_andc(a1, x3);
	x5 = vec_andc(a2, x4);
	x6 = vec_xor(x2, x5);
	x7 = vec_or(x3, x5);
	x8 = vec_andc(x7, x1);
	x9 = vec_or(a3, x8);
	x10 = vec_xor(x6, x9);
	x11 = vec_andc(a5, x4);
	x12 = vec_or(x11, a2);
	x13 = vec_and(a4, x12);
	x14 = vec_xor(x10, x13);
	x14 = vec_nor(x14, x14);
	*out1 = vec_xor(*out1, x14);
	x15 = vec_xor(x4, x14);
	x16 = vec_andc(x15, a2);
	x17 = vec_xor(x2, x16);
	x18 = vec_andc(a6, x4);
	x19 = vec_xor(x6, x11);
	x20 = vec_and(a2, x19);
	x21 = vec_xor(x18, x20);
	x22 = vec_and(a3, x21);
	x23 = vec_xor(x17, x22);
	x24 = vec_xor(a5, a2);
	x25 = vec_andc(x24, x8);
	x26 = vec_or(x6, a1);
	x27 = vec_xor(x26, a2);
	x28 = vec_andc(a3, x27);
	x29 = vec_xor(x25, x28);
	x30 = vec_or(a4, x29);
	x31 = vec_xor(x23, x30);
	*out3 = vec_xor(*out3, x31);
	x32 = vec_or(x18, x25);
	x33 = vec_xor(x32, x10);
	x34 = vec_or(x27, x20);
	x35 = vec_and(a3, x34);
	x36 = vec_xor(x33, x35);
	x37 = vec_and(x24, x34);
	x38 = vec_andc(x12, x37);
	x39 = vec_or(a4, x38);
	x40 = vec_xor(x36, x39);
	x40 = vec_nor(x40, x40);
	*out4 = vec_xor(*out4, x40);
	x41 = vec_xor(a2, x2);
	x42 = vec_andc(x41, x33);
	x43 = vec_xor(x42, x29);
	x44 = vec_andc(a3, x43);
	x45 = vec_xor(x41, x44);
	x46 = vec_or(x3, x20);
	x47 = vec_and(a3, x3);
	x48 = vec_xor(x46, x47);
	x49 = vec_andc(a4, x48);
	x50 = vec_xor(x45, x49);
	x50 = vec_nor(x50, x50);
	*out2 = vec_xor(*out2, x50);
}


static void
s3 (
	altivec	a1,
	altivec	a2,
	altivec	a3,
	altivec	a4,
	altivec	a5,
	altivec	a6,
	altivec	*out1,
	altivec	*out2,
	altivec	*out3,
	altivec	*out4
) {
	altivec	x1, x2, x3, x4, x5, x6, x7, x8;
	altivec	x9, x10, x11, x12, x13, x14, x15, x16;
	altivec	x17, x18, x19, x20, x21, x22, x23, x24;
	altivec	x25, x26, x27, x28, x29, x30, x31, x32;
	altivec	x33, x34, x35, x36, x37, x38, x39, x40;
	altivec	x41, x42, x43, x44, x45, x46, x47, x48;
	altivec	x49, x50, x51, x52, x53;

	x1 = vec_xor(a2, a3);
	x2 = vec_xor(x1, a6);
	x3 = vec_and(a2, x2);
	x4 = vec_or(a5, x3);
	x5 = vec_xor(x2, x4);
	x6 = vec_xor(a3, x3);
	x7 = vec_andc(x6, a5);
	x8 = vec_or(a1, x7);
	x9 = vec_xor(x5, x8);
	x10 = vec_andc(a6, x3);
	x11 = vec_xor(x10, a5);
	x12 = vec_and(a1, x11);
	x13 = vec_xor(a5, x12);
	x14 = vec_or(a4, x13);
	x15 = vec_xor(x9, x14);
	*out4 = vec_xor(*out4, x15);
	x16 = vec_and(a3, a6);
	x17 = vec_or(x16, x3);
	x18 = vec_xor(x17, a5);
	x19 = vec_andc(x2, x7);
	x20 = vec_xor(x19, x16);
	x21 = vec_or(a1, x20);
	x22 = vec_xor(x18, x21);
	x23 = vec_or(a2, x7);
	x24 = vec_xor(x23, x4);
	x25 = vec_or(x11, x19);
	x26 = vec_xor(x25, x17);
	x27 = vec_or(a1, x26);
	x28 = vec_xor(x24, x27);
	x29 = vec_andc(a4, x28);
	x30 = vec_xor(x22, x29);
	x30 = vec_nor(x30, x30);
	*out3 = vec_xor(*out3, x30);
	x31 = vec_and(a3, a5);
	x32 = vec_xor(x31, x2);
	x33 = vec_andc(x7, a3);
	x34 = vec_or(a1, x33);
	x35 = vec_xor(x32, x34);
	x36 = vec_or(x10, x26);
	x37 = vec_xor(a6, x17);
	x38 = vec_andc(x37, x5);
	x39 = vec_and(a1, x38);
	x40 = vec_xor(x36, x39);
	x41 = vec_and(a4, x40);
	x42 = vec_xor(x35, x41);
	*out2 = vec_xor(*out2, x42);
	x43 = vec_or(a2, x19);
	x44 = vec_xor(x43, x18);
	x45 = vec_and(a6, x15);
	x46 = vec_xor(x45, x6);
	x47 = vec_andc(x46, a1);
	x48 = vec_xor(x44, x47);
	x49 = vec_andc(x42, x23);
	x50 = vec_or(a1, x49);
	x51 = vec_xor(x47, x50);
	x52 = vec_and(a4, x51);
	x53 = vec_xor(x48, x52);
	x53 = vec_nor(x53, x53);
	*out1 = vec_xor(*out1, x53);
}


static void
s4 (
	altivec	a1,
	altivec	a2,
	altivec	a3,
	altivec	a4,
	altivec	a5,
	altivec	a6,
	altivec	*out1,
	altivec	*out2,
	altivec	*out3,
	altivec	*out4
) {
	altivec	x1, x2, x3, x4, x5, x6, x7, x8;
	altivec	x9, x10, x11, x12, x13, x14, x15, x16;
	altivec	x17, x18, x19, x20, x21, x22, x23, x24;
	altivec	x25, x26, x27, x28, x29, x30, x31, x32;
	altivec	x33, x34, x35, x36, x37, x38, x39;

	x1 = vec_or(a1, a3);
	x2 = vec_and(a5, x1);
	x3 = vec_xor(a1, x2);
	x4 = vec_or(a2, a3);
	x5 = vec_xor(x3, x4);
	x6 = vec_andc(a3, a1);
	x7 = vec_or(x6, x3);
	x8 = vec_and(a2, x7);
	x9 = vec_xor(a5, x8);
	x10 = vec_and(a4, x9);
	x11 = vec_xor(x5, x10);
	x12 = vec_xor(a3, x2);
	x13 = vec_andc(a2, x12);
	x14 = vec_xor(x7, x13);
	x15 = vec_or(x12, x3);
	x16 = vec_xor(a3, a5);
	x17 = vec_andc(x16, a2);
	x18 = vec_xor(x15, x17);
	x19 = vec_or(a4, x18);
	x20 = vec_xor(x14, x19);
	x21 = vec_or(a6, x20);
	x22 = vec_xor(x11, x21);
	*out1 = vec_xor(*out1, x22);
	x23 = vec_and(a6, x20);
	x24 = vec_xor(x23, x11);
	x24 = vec_nor(x24, x24);
	*out2 = vec_xor(*out2, x24);
	x25 = vec_and(a2, x9);
	x26 = vec_xor(x25, x15);
	x27 = vec_xor(a3, x8);
	x28 = vec_xor(x27, x17);
	x29 = vec_andc(a4, x28);
	x30 = vec_xor(x26, x29);
	x31 = vec_xor(x11, x30);
	x32 = vec_andc(a2, x31);
	x33 = vec_xor(x22, x32);
	x34 = vec_andc(x31, a4);
	x35 = vec_xor(x33, x34);
	x36 = vec_or(a6, x35);
	x37 = vec_xor(x30, x36);
	x37 = vec_nor(x37, x37);
	*out3 = vec_xor(*out3, x37);
	x38 = vec_xor(x23, x35);
	x39 = vec_xor(x38, x37);
	*out4 = vec_xor(*out4, x39);
}


static void
s5 (
	altivec	a1,
	altivec	a2,
	altivec	a3,
	altivec	a4,
	altivec	a5,
	altivec	a6,
	altivec	*out1,
	altivec	*out2,
	altivec	*out3,
	altivec	*out4
) {
	altivec	x1, x2, x3, x4, x5, x6, x7, x8;
	altivec	x9, x10, x11, x12, x13, x14, x15, x16;
	altivec	x17, x18, x19, x20, x21, x22, x23, x24;
	altivec	x25, x26, x27, x28, x29, x30, x31, x32;
	altivec	x33, x34, x35, x36, x37, x38, x39, x40;
	altivec	x41, x42, x43, x44, x45, x46, x47, x48;
	altivec	x49, x50, x51, x52, x53, x54, x55, x56;

	x1 = vec_andc(a3, a4);
	x2 = vec_xor(x1, a1);
	x3 = vec_andc(a1, a3);
	x4 = vec_or(a6, x3);
	x5 = vec_xor(x2, x4);
	x6 = vec_xor(a4, a1);
	x7 = vec_or(x6, x1);
	x8 = vec_andc(x7, a6);
	x9 = vec_xor(a3, x8);
	x10 = vec_or(a5, x9);
	x11 = vec_xor(x5, x10);
	x12 = vec_and(a3, x7);
	x13 = vec_xor(x12, a4);
	x14 = vec_andc(x13, x3);
	x15 = vec_xor(a4, x3);
	x16 = vec_or(a6, x15);
	x17 = vec_xor(x14, x16);
	x18 = vec_or(a5, x17);
	x19 = vec_xor(x13, x18);
	x20 = vec_andc(x19, a2);
	x21 = vec_xor(x11, x20);
	*out4 = vec_xor(*out4, x21);
	x22 = vec_and(a4, x4);
	x23 = vec_xor(x22, x17);
	x24 = vec_xor(a1, x9);
	x25 = vec_and(x2, x24);
	x26 = vec_andc(a5, x25);
	x27 = vec_xor(x23, x26);
	x28 = vec_or(a4, x24);
	x29 = vec_andc(x28, a2);
	x30 = vec_xor(x27, x29);
	*out2 = vec_xor(*out2, x30);
	x31 = vec_and(x17, x5);
	x32 = vec_andc(x7, x31);
	x33 = vec_andc(x8, a4);
	x34 = vec_xor(x33, a3);
	x35 = vec_and(a5, x34);
	x36 = vec_xor(x32, x35);
	x37 = vec_or(x13, x16);
	x38 = vec_xor(x9, x31);
	x39 = vec_or(a5, x38);
	x40 = vec_xor(x37, x39);
	x41 = vec_or(a2, x40);
	x42 = vec_xor(x36, x41);
	x42 = vec_nor(x42, x42);
	*out3 = vec_xor(*out3, x42);
	x43 = vec_andc(x19, x32);
	x44 = vec_xor(x43, x24);
	x45 = vec_or(x27, x43);
	x46 = vec_xor(x45, x6);
	x47 = vec_andc(a5, x46);
	x48 = vec_xor(x44, x47);
	x49 = vec_and(x6, x38);
	x50 = vec_xor(x49, x34);
	x51 = vec_xor(x21, x38);
	x52 = vec_andc(x28, x51);
	x53 = vec_and(a5, x52);
	x54 = vec_xor(x50, x53);
	x55 = vec_or(a2, x54);
	x56 = vec_xor(x48, x55);
	*out1 = vec_xor(*out1, x56);
}


static void
s6 (
	altivec	a1,
	altivec	a2,
	altivec	a3,
	altivec	a4,
	altivec	a5,
	altivec	a6,
	altivec	*out1,
	altivec	*out2,
	altivec	*out3,
	altivec	*out4
) {
	altivec	x1, x2, x3, x4, x5, x6, x7, x8;
	altivec	x9, x10, x11, x12, x13, x14, x15, x16;
	altivec	x17, x18, x19, x20, x21, x22, x23, x24;
	altivec	x25, x26, x27, x28, x29, x30, x31, x32;
	altivec	x33, x34, x35, x36, x37, x38, x39, x40;
	altivec	x41, x42, x43, x44, x45, x46, x47, x48;
	altivec	x49, x50, x51, x52, x53;

	x1 = vec_xor(a5, a1);
	x2 = vec_xor(x1, a6);
	x3 = vec_and(a1, a6);
	x4 = vec_andc(x3, a5);
	x5 = vec_andc(a4, x4);
	x6 = vec_xor(x2, x5);
	x7 = vec_xor(a6, x3);
	x8 = vec_or(x4, x7);
	x9 = vec_andc(x8, a4);
	x10 = vec_xor(x7, x9);
	x11 = vec_and(a2, x10);
	x12 = vec_xor(x6, x11);
	x13 = vec_or(a6, x6);
	x14 = vec_andc(x13, a5);
	x15 = vec_or(x4, x10);
	x16 = vec_andc(a2, x15);
	x17 = vec_xor(x14, x16);
	x18 = vec_andc(x17, a3);
	x19 = vec_xor(x12, x18);
	x19 = vec_nor(x19, x19);
	*out1 = vec_xor(*out1, x19);
	x20 = vec_andc(x19, x1);
	x21 = vec_xor(x20, x15);
	x22 = vec_andc(a6, x21);
	x23 = vec_xor(x22, x6);
	x24 = vec_andc(a2, x23);
	x25 = vec_xor(x21, x24);
	x26 = vec_or(a5, a6);
	x27 = vec_andc(x26, x1);
	x28 = vec_andc(a2, x24);
	x29 = vec_xor(x27, x28);
	x30 = vec_andc(a3, x29);
	x31 = vec_xor(x25, x30);
	x31 = vec_nor(x31, x31);
	*out4 = vec_xor(*out4, x31);
	x32 = vec_xor(x3, x6);
	x33 = vec_andc(x32, x10);
	x34 = vec_xor(a6, x25);
	x35 = vec_andc(a5, x34);
	x36 = vec_andc(a2, x35);
	x37 = vec_xor(x33, x36);
	x38 = vec_andc(x21, a5);
	x39 = vec_or(a3, x38);
	x40 = vec_xor(x37, x39);
	x40 = vec_nor(x40, x40);
	*out3 = vec_xor(*out3, x40);
	x41 = vec_or(x35, x2);
	x42 = vec_and(a5, x7);
	x43 = vec_andc(a4, x42);
	x44 = vec_or(a2, x43);
	x45 = vec_xor(x41, x44);
	x46 = vec_or(x23, x35);
	x47 = vec_xor(x46, x5);
	x48 = vec_and(x26, x33);
	x49 = vec_xor(x48, x2);
	x50 = vec_and(a2, x49);
	x51 = vec_xor(x47, x50);
	x52 = vec_andc(a3, x51);
	x53 = vec_xor(x45, x52);
	x53 = vec_nor(x53, x53);
	*out2 = vec_xor(*out2, x53);
}


static void
s7 (
	altivec	a1,
	altivec	a2,
	altivec	a3,
	altivec	a4,
	altivec	a5,
	altivec	a6,
	altivec	*out1,
	altivec	*out2,
	altivec	*out3,
	altivec	*out4
) {
	altivec	x1, x2, x3, x4, x5, x6, x7, x8;
	altivec	x9, x10, x11, x12, x13, x14, x15, x16;
	altivec	x17, x18, x19, x20, x21, x22, x23, x24;
	altivec	x25, x26, x27, x28, x29, x30, x31, x32;
	altivec	x33, x34, x35, x36, x37, x38, x39, x40;
	altivec	x41, x42, x43, x44, x45, x46, x47, x48;
	altivec	x49, x50, x51;

	x1 = vec_and(a2, a4);
	x2 = vec_xor(x1, a5);
	x3 = vec_and(a4, x2);
	x4 = vec_xor(x3, a2);
	x5 = vec_andc(a3, x4);
	x6 = vec_xor(x2, x5);
	x7 = vec_xor(a3, x5);
	x8 = vec_andc(a6, x7);
	x9 = vec_xor(x6, x8);
	x10 = vec_or(a2, a4);
	x11 = vec_or(x10, a5);
	x12 = vec_andc(a5, a2);
	x13 = vec_or(a3, x12);
	x14 = vec_xor(x11, x13);
	x15 = vec_xor(x3, x6);
	x16 = vec_or(a6, x15);
	x17 = vec_xor(x14, x16);
	x18 = vec_and(a1, x17);
	x19 = vec_xor(x9, x18);
	*out1 = vec_xor(*out1, x19);
	x20 = vec_andc(a4, a3);
	x21 = vec_andc(a2, x20);
	x22 = vec_and(a6, x21);
	x23 = vec_xor(x9, x22);
	x24 = vec_xor(a4, x4);
	x25 = vec_or(a3, x3);
	x26 = vec_xor(x24, x25);
	x27 = vec_xor(a3, x3);
	x28 = vec_and(x27, a2);
	x29 = vec_andc(a6, x28);
	x30 = vec_xor(x26, x29);
	x31 = vec_or(a1, x30);
	x32 = vec_xor(x23, x31);
	x32 = vec_nor(x32, x32);
	*out2 = vec_xor(*out2, x32);
	x33 = vec_xor(x7, x30);
	x34 = vec_or(a2, x24);
	x35 = vec_xor(x34, x19);
	x36 = vec_andc(x35, a6);
	x37 = vec_xor(x33, x36);
	x38 = vec_andc(x26, a3);
	x39 = vec_or(x38, x30);
	x40 = vec_andc(x39, a1);
	x41 = vec_xor(x37, x40);
	*out3 = vec_xor(*out3, x41);
	x42 = vec_or(a5, x20);
	x43 = vec_xor(x42, x33);
	x44 = vec_xor(a2, x15);
	x45 = vec_andc(x24, x44);
	x46 = vec_and(a6, x45);
	x47 = vec_xor(x43, x46);
	x48 = vec_and(a3, x22);
	x49 = vec_xor(x48, x46);
	x50 = vec_or(a1, x49);
	x51 = vec_xor(x47, x50);
	*out4 = vec_xor(*out4, x51);
}


static void
s8 (
	altivec	a1,
	altivec	a2,
	altivec	a3,
	altivec	a4,
	altivec	a5,
	altivec	a6,
	altivec	*out1,
	altivec	*out2,
	altivec	*out3,
	altivec	*out4
) {
	altivec	x1, x2, x3, x4, x5, x6, x7, x8;
	altivec	x9, x10, x11, x12, x13, x14, x15, x16;
	altivec	x17, x18, x19, x20, x21, x22, x23, x24;
	altivec	x25, x26, x27, x28, x29, x30, x31, x32;
	altivec	x33, x34, x35, x36, x37, x38, x39, x40;
	altivec	x41, x42, x43, x44, x45, x46, x47, x48;
	altivec	x49, x50;

	x1 = vec_xor(a3, a1);
	x2 = vec_andc(a1, a3);
	x3 = vec_xor(x2, a4);
	x4 = vec_or(a5, x3);
	x5 = vec_xor(x1, x4);
	x6 = vec_andc(x5, a1);
	x7 = vec_xor(x6, a3);
	x8 = vec_andc(x7, a5);
	x9 = vec_xor(a4, x8);
	x10 = vec_andc(a2, x9);
	x11 = vec_xor(x5, x10);
	x12 = vec_or(x6, a4);
	x13 = vec_xor(x12, x1);
	x14 = vec_xor(x13, a5);
	x15 = vec_andc(x3, x14);
	x16 = vec_xor(x15, x7);
	x17 = vec_andc(a2, x16);
	x18 = vec_xor(x14, x17);
	x19 = vec_or(a6, x18);
	x20 = vec_xor(x11, x19);
	x20 = vec_nor(x20, x20);
	*out1 = vec_xor(*out1, x20);
	x21 = vec_or(x5, a5);
	x22 = vec_xor(x21, x3);
	x23 = vec_andc(x11, a4);
	x24 = vec_andc(a2, x23);
	x25 = vec_xor(x22, x24);
	x26 = vec_and(a1, x21);
	x27 = vec_and(a5, x2);
	x28 = vec_xor(x27, x23);
	x29 = vec_and(a2, x28);
	x30 = vec_xor(x26, x29);
	x31 = vec_andc(x30, a6);
	x32 = vec_xor(x25, x31);
	*out3 = vec_xor(*out3, x32);
	x33 = vec_andc(a3, x16);
	x34 = vec_or(x9, x33);
	x35 = vec_or(a2, x6);
	x36 = vec_xor(x34, x35);
	x37 = vec_andc(x2, x14);
	x38 = vec_or(x22, x32);
	x39 = vec_andc(a2, x38);
	x40 = vec_xor(x37, x39);
	x41 = vec_or(a6, x40);
	x42 = vec_xor(x36, x41);
	x42 = vec_nor(x42, x42);
	*out2 = vec_xor(*out2, x42);
	x43 = vec_andc(x1, a5);
	x44 = vec_or(x43, a4);
	x45 = vec_xor(a3, a5);
	x46 = vec_xor(x45, x37);
	x47 = vec_andc(x46, a2);
	x48 = vec_xor(x44, x47);
	x49 = vec_and(a6, x48);
	x50 = vec_xor(x11, x49);
	x50 = vec_nor(x50, x50);
	*out4 = vec_xor(*out4, x50);
}
